$
$   TOPPERS/ASP Kernel
$       Toyohashi Open Platform for Embedded Real-Time Systems/
$       Advanced Standard Profile Kernel
$ 
$   Copyright (C) 2007 by TAKAGI Nobuhisa
$   Copyright (C) 2007-2015 by Embedded and Real-Time Systems Laboratory
$               Graduate School of Information Science, Nagoya Univ., JAPAN
$ 
$   上記著作権者は，以下の(1)〜(4)の条件を満たす場合に限り，本ソフトウェ
$   ア（本ソフトウェアを改変したものを含む．以下同じ）を使用・複製・改
$   変・再配布（以下，利用と呼ぶ）することを無償で許諾する．
$   (1) 本ソフトウェアをソースコードの形で利用する場合には，上記の著作
$       権表示，この利用条件および下記の無保証規定が，そのままの形でソー
$       スコード中に含まれていること．
$   (2) 本ソフトウェアを，ライブラリ形式など，他のソフトウェア開発に使
$       用できる形で再配布する場合には，再配布に伴うドキュメント（利用
$       者マニュアルなど）に，上記の著作権表示，この利用条件および下記
$       の無保証規定を掲載すること．
$   (3) 本ソフトウェアを，機器に組み込むなど，他のソフトウェア開発に使
$       用できない形で再配布する場合には，次のいずれかの条件を満たすこ
$       と．
$     (a) 再配布に伴うドキュメント（利用者マニュアルなど）に，上記の著
$         作権表示，この利用条件および下記の無保証規定を掲載すること．
$     (b) 再配布の形態を，別に定める方法によって，TOPPERSプロジェクトに
$         報告すること．
$   (4) 本ソフトウェアの利用により直接的または間接的に生じるいかなる損
$       害からも，上記著作権者およびTOPPERSプロジェクトを免責すること．
$       また，本ソフトウェアのユーザまたはエンドユーザからのいかなる理
$       由に基づく請求からも，上記著作権者およびTOPPERSプロジェクトを
$       免責すること．
$ 
$   本ソフトウェアは，無保証で提供されているものである．上記著作権者お
$   よびTOPPERSプロジェクトは，本ソフトウェアに関して，特定の使用目的
$   に対する適合性も含めて，いかなる保証も行わない．また，本ソフトウェ
$   アの利用により直接的または間接的に生じたいかなる損害に関しても，そ
$   の責任を負わない．
$ 
$   $Id: cyclic.tf 480 2016-01-03 07:37:12Z ertl-hiro $
$ 

$
$		周期通知機能のテンプレートファイル
$

$
$  kernel_cfg.hの生成
$
$FILE "kernel_cfg.h.new"$

#define TNUM_CYCID	$LENGTH(CYC.ID_LIST)$$NL$
$FOREACH id CYC.ID_LIST$
	#define $id$	$+id$$NL$
$END$

$
$  kernel_cfg.cの生成
$
$FILE "kernel_cfg.c"$

/*$NL$
$SPC$*  Cyclic Handler Functions$NL$
$SPC$*/$NL$
$NL$

$
$  周期通知のID番号を保持する変数
$
$IF USE_EXTERNAL_ID$
	$FOREACH id CYC.ID_LIST$
		const ID $id$_id = $+id$;$NL$
	$END$
$END$

$
$  周期通知ID番号の最大値
$
const ID _kernel_tmax_cycid = (TMIN_CYCID + TNUM_CYCID - 1);$NL$
$NL$

$
$  周期通知初期化ブロック
$
$IF LENGTH(CYC.ID_LIST)$
	$FOREACH cycid CYC.ID_LIST$
$		// cycatrが無効の場合（E_RSATR）［NGKI2383］
$		//（TA_STA以外のビットがセットされている場合）
		$IF (CYC.CYCATR[cycid] & ~TA_STA) != 0$
			$ERROR CYC.TEXT_LINE[cycid]$E_RSATR:$SPC$
				$FORMAT(_("illegal %1% `%2%\' of `%3%\' in %4%"),
					"cycatr", CYC.CYCATR[cycid], cycid, "CRE_CYC")$
			$END$
		$END$

$		// (0 < cyctim && cyctim <= TMAX_RELTIM)でない場合（E_PAR）［NGKI2397］
		$IF !(0 < CYC.CYCTIM[cycid] && CYC.CYCTIM[cycid] <= TMAX_RELTIM)$
			$ERROR CYC.TEXT_LINE[cycid]$E_PAR:$SPC$
				$FORMAT(_("illegal %1% `%2%\' of `%3%\' in %4%"),
							"cyctim", CYC.CYCTIM[cycid], cycid, "CRE_CYC")$
			$END$
		$END$

$		// (0 <= cycphs && cycphs <= TMAX_RELTIM)でない場合（E_PAR）［NGKI2399］
		$IF !(0 <= CYC.CYCPHS[cycid] && CYC.CYCPHS[cycid] <= TMAX_RELTIM)$
			$ERROR CYC.TEXT_LINE[cycid]$E_PAR:$SPC$
				$FORMAT(_("illegal %1% `%2%\' of `%3%\' in %4%"),
							"cycphs", CYC.CYCPHS[cycid], cycid, "CRE_CYC")$
			$END$
		$END$

$		// 通知情報の処理
		$CYC.NFYHDR[cycid] = GENERATE_NFYHDR(CYC.NFYMODE[cycid],
								CYC.PAR1[cycid], CYC.PAR2[cycid],
								CYC.PAR3[cycid], CYC.PAR4[cycid],
								CYC.TEXT_LINE[cycid], cycid, "CRE_CYC")$
	$END$

$	// 周期通知初期化ブロック
	const CYCINIB _kernel_cycinib_table[TNUM_CYCID] = {$NL$
	$JOINEACH cycid CYC.ID_LIST ",\n"$
		$TAB${$SPC$
			($CYC.CYCATR[cycid]$),$SPC$
			(intptr_t)($CYC.PAR1[cycid]$),$SPC$
			$CYC.NFYHDR[cycid]$,$SPC$
			($CYC.CYCTIM[cycid]$),$SPC$
			($CYC.CYCPHS[cycid]$)$SPC$
		}$END$$NL$
	};$NL$
$ELSE$
	TOPPERS_EMPTY_LABEL(const CYCINIB, _kernel_cycinib_table);$NL$
$END$$NL$

$
$  周期通知管理ブロックと周期通知機能初期化関数
$
$IF LENGTH(CYC.ID_LIST)$
	CYCCB _kernel_cyccb_table[TNUM_CYCID];$NL$
	$initfuncs = APPEND(initfuncs, "_kernel_initialize_cyclic();")$
$ELSE$
	TOPPERS_EMPTY_LABEL(CYCCB, _kernel_cyccb_table);$NL$
$END$$NL$
