$
$   TOPPERS/ASP Kernel
$       Toyohashi Open Platform for Embedded Real-Time Systems/
$       Advanced Standard Profile Kernel
$ 
$   Copyright (C) 2007 by TAKAGI Nobuhisa
$   Copyright (C) 2007-2014 by Embedded and Real-Time Systems Laboratory
$               Graduate School of Information Science, Nagoya Univ., JAPAN
$ 
$   上記著作権者は，以下の(1)〜(4)の条件を満たす場合に限り，本ソフトウェ
$   ア（本ソフトウェアを改変したものを含む．以下同じ）を使用・複製・改
$   変・再配布（以下，利用と呼ぶ）することを無償で許諾する．
$   (1) 本ソフトウェアをソースコードの形で利用する場合には，上記の著作
$       権表示，この利用条件および下記の無保証規定が，そのままの形でソー
$       スコード中に含まれていること．
$   (2) 本ソフトウェアを，ライブラリ形式など，他のソフトウェア開発に使
$       用できる形で再配布する場合には，再配布に伴うドキュメント（利用
$       者マニュアルなど）に，上記の著作権表示，この利用条件および下記
$       の無保証規定を掲載すること．
$   (3) 本ソフトウェアを，機器に組み込むなど，他のソフトウェア開発に使
$       用できない形で再配布する場合には，次のいずれかの条件を満たすこ
$       と．
$     (a) 再配布に伴うドキュメント（利用者マニュアルなど）に，上記の著
$         作権表示，この利用条件および下記の無保証規定を掲載すること．
$     (b) 再配布の形態を，別に定める方法によって，TOPPERSプロジェクトに
$         報告すること．
$   (4) 本ソフトウェアの利用により直接的または間接的に生じるいかなる損
$       害からも，上記著作権者およびTOPPERSプロジェクトを免責すること．
$       また，本ソフトウェアのユーザまたはエンドユーザからのいかなる理
$       由に基づく請求からも，上記著作権者およびTOPPERSプロジェクトを
$       免責すること．
$ 
$   本ソフトウェアは，無保証で提供されているものである．上記著作権者お
$   よびTOPPERSプロジェクトは，本ソフトウェアに関して，特定の使用目的
$   に対する適合性も含めて，いかなる保証も行わない．また，本ソフトウェ
$   アの利用により直接的または間接的に生じたいかなる損害に関しても，そ
$   の責任を負わない．
$ 
$   $Id: mempfix.tf 480 2016-01-03 07:37:12Z ertl-hiro $
$ 

$
$		固定長メモリプール機能のテンプレートファイル
$

$
$  kernel_cfg.hの生成
$
$FILE "kernel_cfg.h.new"$

#define TNUM_MPFID	$LENGTH(MPF.ID_LIST)$$NL$
$FOREACH id MPF.ID_LIST$
	#define $id$	$+id$$NL$
$END$

$
$  kernel_cfg.cの生成
$
$FILE "kernel_cfg.c"$

/*$NL$
$SPC$*  Fixed-sized Memorypool Functions$NL$
$SPC$*/$NL$
$NL$

$
$  固定長メモリプールのID番号を保持する変数
$
$IF USE_EXTERNAL_ID$
	$FOREACH id MPF.ID_LIST$
		const ID $id$_id = $+id$;$NL$
	$END$
$END$

$
$  固定長メモリプールID番号の最大値
$
const ID _kernel_tmax_mpfid = (TMIN_MPFID + TNUM_MPFID - 1);$NL$
$NL$

$
$  固定長メモリプール初期化ブロック
$
$IF LENGTH(MPF.ID_LIST)$
	$FOREACH mpfid MPF.ID_LIST$
$		// mpfatrが無効の場合（E_RSATR）［NGKI2225］
$		//（TA_TPRI以外のビットがセットされている場合）
		$IF (MPF.MPFATR[mpfid] & ~TA_TPRI) != 0$
			$ERROR MPF.TEXT_LINE[mpfid]$E_RSATR:$SPC$
				$FORMAT(_("illegal %1% `%2%\' of `%3%\' in %4%"),
							"mpfatr", MPF.MPFATR[mpfid], mpfid, "CRE_MPF")$
			$END$
		$END$

$		// blkcntが0以下の場合（E_PAR）［NGKI2229］
		$IF MPF.BLKCNT[mpfid] <= 0$
			$ERROR MPF.TEXT_LINE[mpfid]$E_PAR:$SPC$
				$FORMAT(_("illegal %1% `%2%\' of `%3%\' in %4%"),
							"blkcnt", MPF.BLKCNT[mpfid], mpfid, "CRE_MPF")$
			$END$
		$END$

$		// blkszが0以下の場合（E_PAR）［NGKI2230］
		$IF MPF.BLKSZ[mpfid] <= 0$
			$ERROR MPF.TEXT_LINE[mpfid]$E_PAR:$SPC$
				$FORMAT(_("illegal %1% `%2%\' of `%3%\' in %4%"),
							"blksz", MPF.BLKSZ[mpfid], mpfid, "CRE_MPF")$
			$END$
		$END$

$		// 固定長メモリプール領域
		$IF EQ(MPF.MPF[mpfid], "NULL")$
			static MPF_T _kernel_mpf_$mpfid$[($MPF.BLKCNT[mpfid]$)$SPC$
									* COUNT_MPF_T($MPF.BLKSZ[mpfid]$)];$NL$
		$END$

$		// mpfmbがNULLでない場合（E_NOSPT）［ASPS0166］
		$IF !EQ(MPF.MPFMB[mpfid], "NULL")$
			$ERROR MPF.TEXT_LINE[mpfid]$E_NOSPT:$SPC$
				$FORMAT(_("illegal %1% `%2%\' of `%3%\' in %4%"),
							"mpfmb", MPF.MPFMB[mpfid], mpfid, "CRE_MPF")$
			$END$
		$END$

$		// 固定長メモリプール管理領域
		static MPFMB _kernel_mpfmb_$mpfid$[$MPF.BLKCNT[mpfid]$];$NL$
	$END$

$	// 固定長メモリプール初期化ブロック
	const MPFINIB _kernel_mpfinib_table[TNUM_MPFID] = {$NL$
	$JOINEACH mpfid MPF.ID_LIST ",\n"$
		$TAB${$SPC$
			($MPF.MPFATR[mpfid]$),$SPC$
			($MPF.BLKCNT[mpfid]$),$SPC$
			ROUND_MPF_T($MPF.BLKSZ[mpfid]$),$SPC$
			$IF EQ(MPF.MPF[mpfid],"NULL")$
				_kernel_mpf_$mpfid$
			$ELSE$
				(void *)($MPF.MPF[mpfid]$)
			$END$,$SPC$
			_kernel_mpfmb_$mpfid$$SPC$
		}$END$$NL$
	};$NL$
$ELSE$
	TOPPERS_EMPTY_LABEL(const MPFINIB, _kernel_mpfinib_table);$NL$
$END$$NL$

$
$  固定長メモリプール管理ブロックと固定長メモリプール機能初期化関数
$
$IF LENGTH(MPF.ID_LIST)$
	MPFCB _kernel_mpfcb_table[TNUM_MPFID];$NL$
	$initfuncs = APPEND(initfuncs, "_kernel_initialize_mempfix();")$
$ELSE$
	TOPPERS_EMPTY_LABEL(MPFCB, _kernel_mpfcb_table);$NL$
$END$$NL$
